clc;
close all;
clear all;
R=300;
N=1000;
T1=67;
T2=68;
T3=69;
D=0.1;
N1=T1/D;
N2=T2/D;
N3=T3/D;
%% trajectory generation
M=50;
error=zeros(M,N);

for jj=1:3
for i1=1:M
[ position,headDirection,temp_velocity] = trajectory_generate_2d( R,N,D );

  r=[];
  for i2=1:N
      %% a simple GC pattern formulation function just for  replication
      [ vector ] = xy_to_vector( position(i2,1),position(i2,2),T1,T2,T3,D );
      r=[r;vector];
  end
%% SOM process

 SOM1=[];
 SOM2=[];
 SOM1=[SOM1;r(1,:)];
 SOM2=[SOM2;[D/2+D/2*cos(pi/3),D/2*sin(pi/3)]];
 pos=zeros(N,2);
for i3=1:N
     %SOM1
     nn=size(SOM1,1);
     d=zeros(1,3*2);
     dis=inf;
     index=inf;
     for i4=1:nn
         dd = distance_compute( r(i3,:),SOM1(i4,:),N1,N2,N3 );%֮ľ
         if dis> dd
            index=i4;
            dis=dd;
         end
     end
     if dis<inf
        pos(i3,:)=SOM2(index,:);
     end
     [ vector,temp_r ] = SOM1_generate( temp_velocity(i3),headDirection(i3),SOM1(index,:),T1,T2,T3,D );
     for i5=1:9
       temp=1;
       for i6=1:nn
         if(vector(i5,:) == SOM1(i6,:))
            temp=0;  
            break;
         else
            continue;
         end
       end
       if  temp==1    
           SOM1=[SOM1;vector(i5,:)];
           [xx,yy] = vector_to_xy( temp_r(i5,:),N1,N2,N3,D );
           SOM2=[SOM2;SOM2(index,:)+[xx,yy]]; 
       end
     end
end

for i7=1:N
    error(i1,i7)=sqrt((pos(i7,1)-position(i7,1))^2+(pos(i7,2)-position(i7,2))^2);
end
ee(jj,i1)=sum(error(i1,:))/N;
end

end
  
    
    
    
    