function [ vector,temp_r ] = SOM1_generate( velocity,Direction,SOM1_win,T1,T2,T3,D )
     N1=T1/D;
     N2=T2/D;
     N3=T3/D;
     vector=zeros(9,6);
     temp_r=zeros(9,6);
     x=velocity*cos(Direction);
     y=velocity*sin(Direction);
     
     temp_r(1,:)= xy_to_vector_mod( x,y,T1,T2,T3,D );
     vector(1,:)=SOM1_win+temp_r(1,:);
     
     temp_r(2,:)=temp_r(1,:)-1;
     temp_r(3,4:6)=temp_r(1,4:6)-1;
     temp_r(3,1:3)=temp_r(1,1:3);
     temp_r(4,4:6)=temp_r(1,4:6)-1;
     temp_r(4,1:3)=temp_r(1,1:3)+1;
     temp_r(5,4:6)=temp_r(1,4:6);
     temp_r(5,1:3)=temp_r(1,1:3)+1;
     temp_r(6,:)=temp_r(1,:)+1;
     temp_r(7,4:6)=temp_r(1,4:6)+1;
     temp_r(7,1:3)=temp_r(1,1:3);
     temp_r(8,4:6)=temp_r(1,4:6)+1;
     temp_r(8,1:3)=temp_r(1,1:3)-1;
     temp_r(9,4:6)=temp_r(1,4:6);
     temp_r(9,1:3)=temp_r(1,1:3)-1;
     temp_r(:,1)=mod(temp_r(:,1),N1);
     temp_r(:,4)=mod(temp_r(:,4),N1);
     temp_r(:,2)=mod(temp_r(:,2),N2);
     temp_r(:,5)=mod(temp_r(:,5),N2); 
     temp_r(:,3)=mod(temp_r(:,3),N3);
     temp_r(:,6)=mod(temp_r(:,6),N3);
     
     vector(2,:)=vector(1,:)-1;
     vector(3,4:6)=vector(1,4:6)-1;
     vector(3,1:3)=vector(1,1:3);
     vector(4,4:6)=vector(1,4:6)-1;
     vector(4,1:3)=vector(1,1:3)+1;
     vector(5,4:6)=vector(1,4:6);
     vector(5,1:3)=vector(1,1:3)+1;
     vector(6,:)=vector(1,:)+1;
     vector(7,4:6)=vector(1,4:6)+1;
     vector(7,1:3)=vector(1,1:3);
     vector(8,4:6)=vector(1,4:6)+1;
     vector(8,1:3)=vector(1,1:3)-1;
     vector(9,4:6)=vector(1,4:6);
     vector(9,1:3)=vector(1,1:3)-1;
     vector(:,1)=mod(vector(:,1),N1);
     vector(:,4)=mod(vector(:,4),N1);
     vector(:,2)=mod(vector(:,2),N2);
     vector(:,5)=mod(vector(:,5),N2); 
     vector(:,3)=mod(vector(:,3),N3);
     vector(:,6)=mod(vector(:,6),N3);
end

