function [vector ] = xy_to_vector( x,y,T1,T2,T3,D )
    xx=x-y/tan(pi/3);
    yy=y/sin(pi/3);
    rx1=mod(xx,T1);
    rx1=floor(rx1/D)+1;
    rx2=mod(xx,T2);
    rx2=floor(rx2/D)+1;
    rx3=mod(xx,T3);
    rx3=floor(rx3/D)+1;
    rx=[rx1,rx2,rx3];
    ry1=mod(yy,T1);
    ry1=floor(ry1/D)+1;
    ry2=mod(yy,T2);
    ry2=floor(ry2/D)+1;
    ry3=mod(yy,T3);
    ry3=floor(ry3/D)+1;
    ry=[ry1,ry2,ry3];
    vector=[rx,ry];
end